#include "PNGimageClass.h"
#include "../lode/lodepng.h"
#include <iostream>
#include <string>
#include <stdlib.h>

using namespace std;

/*class PNGimage {

private:
    vector<unsigned char> rawimage;

    
protected:
    vector<unsigned int> intimage;
    unsigned width, height;
    string filename;

public:*/


/*******************************************************
 * Constructors...                                     *
 *******************************************************/
   PNGimage::PNGimage (std::vector<unsigned int> image,unsigned int w,unsigned int h){
       //PNGimage::CWHITES = 0xffffffff; // Bright white
       width=w;
       height=h;
       rawimage.resize(h*w*4);
       intimage.resize(h*w);
       for(int i=0;i<w*h;i++) {
           intimage[i]=image[i];
       }
       filename="";
       lastPaintMinx=-1;
       lastPaintMiny=-1;
       lastPaintMaxx=-1;
       lastPaintMaxy=-1;
       lastPaintPixels=-1;
   }
    
    PNGimage::PNGimage(string pngfilename) {
       //PNGimage::CWHITES = 0xffffffff; // Bright white
        //load(pngfilename);
        int i,j,k;
          //unsigned error = lodepng::decode(image, width, height, filename);

        unsigned error = lodepng::decode(rawimage,width,height,pngfilename);
        if(error) {
            std::cout << pngfilename <<":KUVAN LATAUKSESSA TULI ERRORIA, KUVA ON JOKO KORRUPTOITUNUT TAI SITÄ EI OLE\n";
            exit(1);
        }
        //std::cout << width << "," << height << "\n";
        intimage.resize(width*height);
        {
            for(i=0;i<width*height;i++) {
                k=4*(i);
                intimage[i]=rawimage[k]+(rawimage[k+1]<<8)+(rawimage[k+2]<<16)+(rawimage[k+3]<<24);
            }
        }
        filename=pngfilename;
        lastPaintMinx=-1;
        lastPaintMiny=-1;
        lastPaintMaxx=-1;
        lastPaintMaxy=-1;
        lastPaintPixels=-1;

    }
    
    PNGimage::PNGimage(const PNGimage &img) {
       //PNGimage::CWHITES = 0xffffffff; // Bright white
        rawimage.resize(img.rawimage.size());
        width=img.width;
        height=img.height;
        intimage.resize(height*width);
        for(int i=0;i<height*width;i++) {
            intimage[i]=img.intimage[i];
        }
        filename=img.filename;
        lastPaintMinx=-1;
        lastPaintMiny=-1;
        lastPaintMaxx=-1;
        lastPaintMaxy=-1;
        lastPaintPixels=-1;
    }



/*******************************************************
 * Methods                                             *
 *******************************************************/


    unsigned int PNGimage::getWidth() {
        return width;
    }
    
    unsigned int PNGimage::getHeight() {
        return height;
    }

    int PNGimage::load(string pngfilename) {
        int i,j,k;
          //unsigned error = lodepng::decode(image, width, height, filename);
        //width=0;height=0;
        rawimage.clear();
        unsigned error = lodepng::decode(rawimage,width,height,pngfilename);
        //cout << width << "," << height << "," << error << "," << pngfilename <<"\n";
        intimage.resize(width*height);
        {
            for(i=0;i<width*height;i++) {
                k=4*(i);
                intimage[i]=rawimage[k]+(rawimage[k+1]<<8)+(rawimage[k+2]<<16)+(rawimage[k+3]<<24);
            }
        }
        filename=pngfilename;
        //error = lodepng::encode("oho.png",rawimage,width,height);
        //cout << width << "," << height <<"\n";
        lastPaintMinx=-1;
        lastPaintMiny=-1;
        lastPaintMaxx=-1;
        lastPaintMaxy=-1;
        lastPaintPixels=-1;
   }
   
    
    unsigned int PNGimage::save(string pngfilename) {
        int i,j,k;
        unsigned int pixel;
        filename=pngfilename;
        rawimage.resize(width*height*4);
        for(int i=0;i<width*height;i++) {
            pixel=intimage[i];
            rawimage[i*4]=(255 & pixel);
            rawimage[i*4+1]=(255 & (pixel>>8));
            rawimage[i*4+2]=(255 & (pixel>>16));
            rawimage[i*4+3]=(255 & (pixel>>24));//255;//(255 & (pixel<<24));
        }
        return lodepng::encode(filename, rawimage, width, height);
    }
    
    void PNGimage::line(long x0,long y0,long x1,long y1,unsigned int color) {
        long i,j,x,y;
        double xx0,yy0,xx1,yy1;
        double k=0,b=0;
        
        xx0=(double)x0;
        yy0=(double)y0;
        xx1=(double)x1;
        yy1=(double)y1;
        
        if((xx0==xx1) && (yy0==yy1)) return;
        if((xx0!=xx1) && (abs(yy0-yy1)<abs(xx0-xx1))) {
            if(x0>x1) {
                xx0=(double)x1;
                xx1=(double)x0;
                yy0=(double)y1;
                yy1=(double)y0;
                x0=(int)xx0;
                x1=(int)xx1;
                y0=(int)yy0;
                y1=(int)yy1;
            }
            k=(yy0-yy1)/(xx0-xx1);
            b=yy0-xx0*k;
            for(x=x0;x<x1;x++) {
                y=(long)(k*(double)x+b);
                if((y>=0) && (x>=0) && (y<height) && (x<width)) {
                    intimage[(unsigned int)((double)(x+width*y))]=color;
                }
            }
            //cout << "(" << xx0 << "," << yy0 << ")-(" << xx1 << "," << yy1 << ")\n" << "(" << x << "," << y << ")\n";
            //cout << "k=" << k << ",b="<< b << "\n";
        } else {
            if(y0>y1) {
                xx0=(double)x1;
                xx1=(double)x0;
                yy0=(double)y1;
                yy1=(double)y0;
                x0=(int)xx0;
                x1=(int)xx1;
                y0=(int)yy0;
                y1=(int)yy1;
            }
            k=(xx1-xx0)/(yy1-yy0);
            b=xx0-k*yy0;
            
            for(y=y0;y<y1;y++) {
                x=k*(double)y+b;
                if((y>=0) && (x>=0) && (y<height) && (x<width)) {
                    intimage[(unsigned int)((double)(0.5+x+width*y))]=color;
                }
            }
        }
    }
    
    void PNGimage::resizeWidth(int newWidth) {
        int i,j;
        if(width>newWidth) {
            //cout << "Tuli widthiin \n";
            for(j=0;j<height;j++) {
                for(i=0;i<newWidth;i++) {
                    intimage[j*newWidth+i]=intimage[j*width+i];
                }
            }
            intimage.resize(newWidth*height);
            width=newWidth;
        } else if(width<newWidth) {
            //cout << "Tuli widthiin suurentamaan...\n";
            intimage.resize(newWidth*height);
            for(j=height-1;j>=0;j--) {
                for(i=width-1;i>=0;i--) {
                    intimage[j*newWidth+i]=intimage[j*width+i];
                }                
            }
            for(j=height-1;j>=0;j--) {
                for(i=newWidth-1;i>=width;i--) {
                    intimage[j*newWidth+i]=0;//intimage[j*width+i];
                }                
            }
            width=newWidth;
        }
    }
    
    void PNGimage::resizeHeight(int newHeight) {
        intimage.resize(newHeight*width);
        height=newHeight;
    }
    
    void PNGimage::resize(int w, int h) {
        if(w!=width) resizeWidth(w);
        if(h!=height) resizeHeight(h);
    }
    
    void PNGimage::changeOneColorToOther(unsigned int fromcolor,unsigned int tocolor) {
        for(int i=0;i<height*width;i++) {
            if(intimage[i]==fromcolor) intimage[i]=tocolor;
        }
    }
    
    void PNGimage::keepOnlyOneColor(unsigned int color, unsigned int bgcolor, unsigned int tocolor) {
        for(int i=0;i<height*width;i++) 
            if(intimage[i]!=color) intimage[i]=bgcolor;
            else intimage[i]=tocolor;
    }
    
    void PNGimage::keepOnlyOneColor(unsigned int color, unsigned int bgcolor) {
        keepOnlyOneColor(color,bgcolor,color);
    }
    
    void PNGimage::trimWidth(unsigned int bgcolor) {
        int i,j,k,marginleft,marginright;
        marginleft=-1;
        for (i=0;i<width;i++) {
            for(j=0;j<height;j++) {
                if(marginleft<0) {
                    if(intimage[i+j*width]!=bgcolor) {
                        marginleft=i;
                    }
                } else {
                    if(intimage[i+j*width]!=bgcolor) {
                        marginright=i;
                    }
                }
            }
        }
        if(marginleft>0) {
            for(i=0;i<height*width-marginleft;i++) {
                intimage[i]=intimage[i+marginleft];
            }
        }
        if(marginleft>0 || marginright<width-1) {
            resize(marginright-marginleft+1,height);
        }
        //cout << marginleft << "," ;
    }
    
    unsigned int PNGimage::getPixel(int x,int y) {
        ;  // returns pixelcolor
        if(x>=0 && x<width && y>=0 && y<height) return intimage[x+y*width];
        return CERROR;
    }
    
    void PNGimage::setPixel(int x, int y, unsigned int color) {
        if(x>=0 && x<width && y>=0 && y<height)
            intimage[x+y*width]=color;
    }
    
    void PNGimage::copyImageTo(PNGimage img,int x0,int y0) {
        int i,j;
        if(x0>=0 && y0>=0) {
            if(width<x0+img.width || height<y0+img.height) {
                if(width<x0+img.width) {
                    resizeWidth(x0+img.width);
                }
                if(height<y0+img.height) {
                    resizeHeight(y0+img.height);
                }
            }
            for(j=0;j<img.height;j++) {
                for(i=0;i<img.width;i++) {
                    intimage[i+x0+(j+y0)*width]=img.intimage[i+j*img.width];
                }
            }
        }
        
    }

    void PNGimage::crop(unsigned int x0,unsigned int y0,unsigned int x1,unsigned int y1) {
        unsigned int i,j;
        if(x0>x1) {
            i=x0;
            x0=x1;
            x1=i;
        }
        
        if(y0>y1) {
            i=y0;
            y0=y1;
            y1=i;
        }
        //std::cout << x0 << "," << y0 << ")-(" << x1 << "," << y1 << ")\n";
        if (x1-x0>width) {
            resizeWidth(x1-x0);
        }
        if (y1-y0>height) {
            resizeHeight(y1-y0);
        }
        for(j=0;j<y1-y0;j++) {
            for(i=0;i<x1-x0;i++) {
                intimage[i+width*j]=intimage[x0+i+width*(j+y0)];
            }
        }
        resize(x1-x0,y1-y0);
    }
    
    void PNGimage::paint (int x,int y, unsigned int fromcolor, unsigned int tocolor //, unsigned int bgcolor
        
    ) {
        vector<int> xx;
        vector<int> yy;
        int lenxxyy=0;
        int result=-1;
        int listidx=0;
        int listroot=0;
        int lastinlist=0;
        int list=0;
        int minx=0,miny=0,maxx=0,maxy=0;
        int pixels=0;
        
        xx.resize(1000);
        yy.resize(1000);
        if(intimage[x+y*width]==fromcolor) {
            result=1;
            listroot=0;
            list=0;
            lastinlist=0;
            xx[list]=x;yy[list]=y;lenxxyy++;
            minx=x;maxx=x;miny=y;maxy=y;
            while (list<=lastinlist) {
                x=xx[list];
                y=yy[list];
                if((x>=0) && (y>=0) && (x<width) && (y<height)) {
                    if(intimage[x+y*width]==fromcolor) {
                        if(x<minx) minx=x;
                        if(x>maxx) maxx=x;
                        if(y<miny) miny=y;
                        if(y>maxy) maxy=y;
                        pixels++;
                        intimage[x+y*width]=tocolor;
                        if(xx.size()<lenxxyy+4) {
                            xx.resize(lenxxyy+1000);
                            yy.resize(lenxxyy+1000);
                        }
                        if(x>0) {
                            if(getPixel(x-1,y)==fromcolor) {
                                lenxxyy++;
                                lastinlist++;
                                xx[lastinlist]=x-1;
                                yy[lastinlist]=y;
                            }
                        }
                        if(x+1<width) {
                            if(getPixel(x+1,y)==fromcolor) {
                                lenxxyy++;
                                lastinlist++;
                                xx[lastinlist]=x+1;
                                yy[lastinlist]=y;
                            }
                        }
                        if(y>0) {
                            if(getPixel(x,y-1)==fromcolor) {
                                lenxxyy++;
                                lastinlist++;
                                xx[lastinlist]=x;
                                yy[lastinlist]=y-1;
                            }
                        }
                        if(y+1<height) {
                            if(getPixel(x,y+1)==fromcolor) {
                                lenxxyy++;
                                lastinlist++;
                                xx[lastinlist]=x;
                                yy[lastinlist]=y+1;
                            }
                        }
                    }
                }
                list++;
            }
            lastPaintPixels=pixels;
            lastPaintMinx=minx;
            lastPaintMiny=miny;
            lastPaintMaxx=maxx;
            lastPaintMaxy=maxy;
        }
    }

    //void PNGimage::paint (int x,int y, unsigned int tocolor ) { //, unsigned int bgcolor
        
        //
      //  unsigned int fromcolor=getPixel(x,y);
        //this.paint(x,y,fromcolor,tocolor);
    //}

//};
