#include "../lode/lodepng.h"
#include <iostream>
#include <string>


#ifndef PNG_IMAGE_CLASS
#define PNG_IMAGE_CLASS

using namespace std;


class PNGimage {

private:
    vector<unsigned char> rawimage;

    
protected:
    vector<unsigned int> intimage;
    unsigned int width;
    unsigned int height;
    std::string filename;
    
    int lastPaintMinx;
    int lastPaintMiny;
    int lastPaintMaxx;
    int lastPaintMaxy;
    int lastPaintPixels;
    
    void resizeWidth(int newWidth);

    void resizeHeight(int newHeight);

public:
    static const unsigned int CBLACK = 0xff000000; // Black
    static const unsigned int CBLUE =  0xffff0000; // Blue
    static const unsigned int CYELLOW= 0xff00ffff; // Yellow
    static const unsigned int CGREEN = 0xff00ff00; // Green
    static const unsigned int CRED =   0xff0000ff; // Red
    static const unsigned int CWHITE = (unsigned int)0xffffffff; // Bright white
    static const unsigned int CFROMCOLOR    = 0xfff1f1f1;
    static const unsigned int CTRANSPARENT = 0x00ffffff; // Transparent
    static const unsigned int CERROR       = 0x00fffffe; // Getpixel error
    //const double NOITALICK = 0.3333333333333333333;//0.337203;

    /***********************************************************
     * Constructors                                            *
     ***********************************************************/
    PNGimage(string pngfilename); 
    
    PNGimage(std::vector<unsigned int> image,unsigned int w,unsigned int h);

    PNGimage(const PNGimage &img);
    
    /*********************************************************** 
     * Methods                                                 *
     ***********************************************************/

    int load(string pngfilename); 
    
    unsigned int save(string pngfilename);
    
    unsigned int getWidth();
    
    unsigned int getHeight();
    
    void line(long x0,long y0,long x1,long y1,unsigned int color);

    void resize(int w, int h);
    
    void keepOnlyOneColor(unsigned int color, unsigned int bgcolor, unsigned int tocolor); // color = fromcolor

    void keepOnlyOneColor(unsigned int color, unsigned int bgcolor); // tocolor=color
    
    void changeOneColorToOther(unsigned int fromcolor,unsigned int tocolor);
    
    void trimWidth(unsigned int bgcolor);
    
    unsigned int getPixel(int x,int y);  // returns pixelcolor
    
    void setPixel(int x, int y, unsigned int color);

    
    //void paint(int x,int y, unsigned int tocolor); //, unsigned int bgcolor);
    
    void paint(int x,int y, unsigned int fromcolor, unsigned int tocolor); //, unsigned int bgcolor);
    
        
    void copyImageTo(PNGimage img,int x0,int y0);
    
    void crop(unsigned int x0,unsigned int y0,unsigned int x1,unsigned int y1);
};

#endif
