//#ifndef WORD_IMAGE_CLASSSRC
//#define WORD_IMAGE_CLASSSRC
#include "PNSClass.h"
#include "../lode/lodepng.h"
#include "PNGimageClass.h"
#include "YlebmpClass.h"
#include <iostream>
#include <string>
#include <stdlib.h>



//using namespace std;

    YLEbmp::YLEbmp(std::string pngfilename):PNGimage(pngfilename) {
        italicb=-10000;
        italick=-10000;
        italicbdelta=-10000;
        italickdelta=-10000; 
        marginleft=0;
        marginright=0;
        isitalic=false;
        avglen=0;
        pnslen=0;
        pns.resize(50);
    };

    YLEbmp::YLEbmp(std::vector<unsigned int> image,unsigned int w,unsigned int h):PNGimage(image,w,h) {
        italicb=-10000;
        italick=-10000;
        italicbdelta=-10000;
        italickdelta=-10000; 
        isitalic=false;
        avglen=0;// = 0;
        marginleft=0;
        marginright=0;
        pnslen=0;
        pns.resize(50);

    };
    //WordImage
    
    int YLEbmp::isItalic() { // 0 == unknown, 1 <= Italic, -1 >= Normal
        int i,j,k;
        PNSClass *dd;
        if(italicb>-9000) return isitalic;
        else {
            if(getPNSlen()==0) {
                createPNSlist();
            }
            isitalic=0;
            for(i=0;(i<getPNSlen()) && (isitalic==0);i++) {
                for(j=0;(j<getPNSlen())&&(isitalic==0);j++) {
                    if(pns[j]->getItalicb()>=-0.01) {
                        isitalic=-1;
                        italicb=pns[j]->getItalicb();
                        return isitalic;
                    }
                    if(pns[i]->getItalicb()>pns[j]->getItalicb()) {
                        dd=pns[i];
                        pns[i]=pns[j];
                        pns[j]=dd;
                    }
                }
            }
            //if((getPNSlen()==1
            if(isitalic!=0) return isitalic;
            i=getPNSlen();
            if(i==0) return 0;
            if((i&1)==1) {
                italicb=(pns[i/2])->getItalicb();
            } else {
                italicb=(pns[i/2]->getItalicb()+pns[i/2-1]->getItalicb())/2;
            }
            if(italicb<-0.16) { 
                isitalic=2;         // Varmuudella italic, sillä >0
            } else if(italicb>-0.077 ) {
                isitalic=-2;        // Varmuudella normaali, sillä <0
            } else {
                isitalic=0;         // Varmuudella ehkä, sillä ==0
            }
        }
        return isitalic;
    }
    
    void YLEbmp::createPNSlist() {
        int i;
        for(i=0;i<pnslen;i++) {
            delete pns[i];//.delete();
        }/**/
        pnslen=0;
        for(i=0;i<height*width;i++) {
            if((intimage[i]==CBLACK)||(intimage[i]==CRED)||(intimage[i]==CBLUE)) {
                intimage[i]=CBLUE;
            } else {
                intimage[i]=CWHITE;
            }
        }/**/
        calcCharsAvgs(CBLUE,CRED,CBLACK);
    }
    
    PNSClass *YLEbmp::getPNS(int nro) {
        if((nro<pnslen)&&(nro>=0)) return pns[nro];
        return NULL;
    }
    
    int YLEbmp::getPNSlen() {
        return pnslen;
    }


    void YLEbmp::calcMinOfSquare(unsigned int fromcolor,unsigned int tocolor,int x0,int y0,int x1,int y1) {
        int i,j,k;
        double sumx=0;
        int nx=0,n=0;
        avglen=0;
        avgx.resize(y1-y0);
        avgy.resize(y1-y0);
        for(j=0;j+y0<y1;j++) {
            sumx=0;
            nx=0;
             for(i=0;i+x0<x1;i++) {
                if(intimage[i+x0+(y0+j)*width]==fromcolor) {
                   sumx=sumx+i; 
                   nx++;
                   intimage[i+x0+(y0+j)*width]=tocolor;
                }
             }
             if(nx>0) {
                avgx[n]=sumx/(double)nx;
                avgy[n]=j+y0;
                n++;
            }
        }
        avglen=n;
        if(pnslen>=pns.size()) {
            pns.resize(pns.size()+50);
        }
        if(PNSClass::debug!=0) {
            std::cout << "N=" << avglen << "\n ";
            for(i=0;i<avglen;i++) {
                std::cout << "TULI JES:" << avgx[i] << "," << avgy[i] << "\n";
            }
        }
        pns[pnslen]=new PNSClass(avgy,avgx,avglen);
        if(PNSClass::debug!=0) {
            std::cout << "?pnslen=" << pnslen <<"," << pns.size() << "\n";
        }
        pnslen++;
    }
    
    void YLEbmp::calcCharsAvgs(unsigned int fromcolor,unsigned int tocolor,unsigned int tocolor2) {
        int i,j,k;
        int w=width;
        if(pnslen==0) {
            j=height/2;
            for(i=0;i<width;i++) {
                if(intimage[i+j*w]==fromcolor) {
                    paint(i,j,fromcolor,tocolor);
                    calcMinOfSquare(tocolor,tocolor2,lastPaintMinx,lastPaintMiny,lastPaintMaxx,lastPaintMaxy);
                }
            }
        }
    }
    
    void YLEbmp::cleanDusts(unsigned int fromcolor, unsigned int tocolor, unsigned int bgcolor) { 
        int i,j;

        for(j=0;j<height;j++) {
            for(i=0;i<width;i++) {
                if(intimage[i+j*width]==fromcolor) {
                    //std::cout << "???\n";
                    paint(i,j,fromcolor,tocolor);
                    if(((lastPaintMinx+2>=lastPaintMaxx) || (lastPaintMiny+1>=lastPaintMaxy)) || (lastPaintPixels<12)) {
                        //std::cout << lastPaintPixels << "--(" << (lastPaintMaxx-lastPaintMinx) << "," << (lastPaintMaxy-lastPaintMiny) << ")\n";
                        paint(i,j,tocolor,bgcolor);
                    }
                }   
            }       
        }
    }

    bool YLEbmp::isPixelsX(int x,unsigned int bgcolor) {
        for(int j=0;j<height;j++) {
            if(intimage[x+j*width]!=bgcolor) {
                return true;
            }
        }
        return false;
    }

    
    int YLEbmp::makeItalicToNormalBmp(unsigned int bgcolor) {
        int marginleftold=0;
        int marginrightold=0;
        long x0,y0,x1,y1;
        int widthold,heightold;
        int i,j,k;
        double x,y;
        vector <unsigned int> bmp;
        
        widthold=width;
        heightold=height;
        for(i=0;i<widthold;i++) {
            if(isPixelsX(i,bgcolor)) {
                break;
            }
        }
        if(i<widthold) {
            marginleftold=i;
        }
        for(i=widthold-1;i<=0;i--) {
            if(isPixelsX(i,bgcolor)) {
                break;
            }
        }
        marginrightold=widthold-i-1;
        
        //std::cout << "marginleftold="<< marginleftold <<", marginrightold"<< marginrightold << "\n";
        
        x0=(long)width*3; // Määritellään laatikko, joka muutetaan noitalic:ksi.
        y0=(long)height;
        x1=-1*(long)width*3;
        y1=0;
        for(i=marginleftold;i<widthold-marginrightold;i++) {
            for(j=0;j<heightold;j++) {
                if(intimage[i+widthold*j]!=bgcolor) {
                    x=(double)i+NOITALICK*j+0.5;
                    y=(double)j+0.5;
                    if(x<x0) x0=(int)x;
                    if(x>x1) x1=(int)x;
                    if(y<y0) y0=(int)y;
                    if(y>y1) y1=(int)y;
                }
            }
        }
        //std::cout << "(x0,y0)=(" << x0 <<"," << y0 << ")-(x1,y1)-("<<x1<<","<<y1<<")\n";
        width=marginleftold+x1-x0+marginrightold;
        bmp.resize(width*height);//,CWHITES);
        for(j=0;j<width*height;j++) {
                bmp[j]=CWHITE;
        }
        for(j=y0;j<y1;j++) {
            for(i=marginleftold;i<widthold-marginrightold;i++) {
                if(intimage[i+widthold*j]!=CWHITE) {
                    x=(double)i+NOITALICK*j+marginleftold-1;
                    if(x-x0<0) x=x0;
                    y=(double)j+.5;
                    bmp[(int)x-x0+((int)y)*width]=CBLACK;
                }
            }
        }
        if(bmp.size()==0) {
            height=heightold;width=widthold;
            std::cout << "Pikku virhettä, joten ei kursiivin korjausta\n";
            return -1;
        } else {
            intimage.resize(width*height);
            for(i=0;i<width*height;i++) {
                intimage[i]=bmp[i];
            }
            return 0;
        }
        return -2;
    };
//#endif
